@* The exponential of a functional. %%
@c
/* Empty, waiting for |export| */
@ @(functional/exp.h@>=
#ifndef __MATH_EXP_FUNCTIONAL__
#define __MATH_EXP_FUNCTIONAL__ 1.00
#include <math.h>
#include <math/functionalbase.h>
namespace math
{
    @[namespace functional@]
    {
	template<class T>@;
	class @[exp : public base<T>@]
	{
	    @<Exponential of a functional internal variables@>@;
	public:@;
	    @<Exponential of a functional class methods@>@;
	};
    }
}
#endif
@ @<Exponential of a functional internal variables@>=
typedef base<T>* element_type;
element_type f;
@ @<Exponential of a functional class methods@>=
exp(element_type new_f) @[:@] f(new_f) @+{@+}
@ @<Exponential of a functional class methods@>=
T eval(const matrix<T,unstructured,dense>& x)
{
    return ::exp(f->eval(x));
}
@ The gradient of the exponential is given by $e^f\nabla f$.
@ @<Exponential of a functional class methods@>=
matrix<T,unstructured,dense>& grad(const matrix<T,unstructured,dense>& x,
				   matrix<T,unstructured,dense>& dest)
{
    f->grad(x,dest);
    return dest*=eval(x);
}
@ The Hessian is given by $e^f\nabla^2 f + e^f\nabla f\nabla^Tf$.
@<Exponential of a functional internal variables@>=
matrix<T,symmetric,dense> Hdense;
matrix<T,symmetric,sparse> Hsparse;
matrix<T,unstructured,dense> aux;
@ @<Exponential of a functional class methods@>=
matrix<T,symmetric,dense> &hess(const matrix<T,unstructured,dense>&x, matrix<T,symmetric,dense>&
				dest)
{
    f->grad(x,aux);
    outerp(aux,&Hdense);
    f->hess(x,dest);
    dest+=Hdense;
    return dest*=eval(x);
}
matrix<T,symmetric,sparse> &hess(const matrix<T,unstructured,dense>&x, matrix<T,symmetric,sparse>&
				dest)
{
    f->grad(x,aux);
    outerp(aux,&Hsparse);
    f->hess(x,dest);
    dest+=Hsparse;
    return dest*=eval(x);
}
