@* The product of two functionals.
@c
/* Empty, waiting for |export| */
@ @(functional/prod.h@>=
#ifndef __MATH_PROD_FUNCTIONAL__
#define __MATH_PROD_FUNCTIONAL__ 1.00
#include <math/functionalbase.h>
namespace math
{
    @[namespace functional@]
    {
	template<class T>@;
	class @[prod : public base<T>@]
	{
	    @<Product of functionals internal variables@>@;
	public:@;
	    @<Product of functionals class methods@>@;
	};
    }
}
#endif
@ @<Product of functionals internal variables@>=
typedef base<T>* element_type;
element_type f,g;
@ @<Product of functionals class methods@>=
prod(element_type new_f, element_type new_g) @[:@] f(new_f), g(new_g) @+{@+}
@ @<Product of functionals class methods@>=
T eval(const matrix<T,unstructured,dense>& x)@+
{@+
    return f->eval(x)*g->eval(x);@+
}
@ The gradient of the product is given by $f\nabla g+g\nabla f$.
@<Product of functionals internal variables@>=
matrix<T,unstructured,dense> aux;
@ @<Product of functionals class methods@>=
matrix<T,unstructured,dense>& grad(const matrix<T,unstructured,dense>& x,
				   matrix<T,unstructured,dense>& dest)
{
    f->grad(x,aux);
    aux*=g->eval(x);
    g->grad(x,dest);
    dest*=f->eval(x);
    return dest+=aux;
}
@ The Hessian is given by $g\nabla^2f+\nabla f\nabla^Tg+\nabla g\nabla^Tf+f\nabla^2g$.
@<Product of functionals internal variables@>=
matrix<T,unstructured,dense> xua;
matrix<T,symmetric,dense> Hdense;
matrix<T,symmetric,sparse> Hsparse;
@ @<Product of functionals class methods@>=
matrix<T,symmetric,dense> &hess(const matrix<T,unstructured,dense>&x, matrix<T,symmetric,dense>&
				dest)
{
    f->hess(x,dest);
    dest*=g->eval(x);
    g->hess(x,Hdense);
    Hdense*=f->eval(x);
    dest+=Hdense;
    f->grad(x,aux);
    g->grad(x,xua);
    dest+=xyyx(aux,xua,&Hdense);
    return dest;
}
matrix<T,symmetric,sparse> &hess(const matrix<T,unstructured,dense>&x, matrix<T,symmetric,sparse>&
				dest)
{
    f->hess(x,dest);
    dest*=g->eval(x);
    g->hess(x,Hsparse);
    Hsparse*=f->eval(x);
    dest+=Hsparse;
    f->grad(x,aux);
    g->grad(x,xua);
    dest+=xyyx(aux,xua,&Hsparse);
    return dest;
}
